/*
 * acceleration.h
 *
 *  Created on: 01.01.2011
 *      Author: AndreR
 */

#ifndef __ACCELERATION_H__
#define __ACCELERATION_H__

#include "stm32f10x.h"
#include "hal/spi/lis3.h"

typedef struct _AccelerationGlobal
{
	LIS3 inner;
	LIS3 outer;

	volatile int16_t raw[6];
	volatile int16_t offset[6];

	struct
	{
		int32_t x;
		int32_t y;
	} velocity;

	struct
	{
		int32_t x;
		int32_t y;
	} sum;

	uint8_t logEnabled;
} AccelerationGlobal;

extern AccelerationGlobal acceleration;

void AccelerationInit();
void AccelerationTask(void* params);
void AccelerationCalibrate();
void AccelerationSetLogging(uint8_t enable);

#endif /* ACCELERATION_H_ */
