/*
 * constants.h
 *
 *  Created on: 13.02.2011
 *      Author: AndreR
 */

#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__

/////////////////////////////////////////////////
// Buffer Sizes
/////////////////////////////////////////////////

// DECT
#define DECT_DMA_TX_SIZE 2000
#define DECT_HDLC_RX_SIZE 2000
#define DECT_HDLC_TX_SIZE 2100

// NETWORK
#define NETWORK_TX_PROCESSING_SIZE	1500
#define NETWORK_RX_PROCESSING_SIZE	1500

// SPI
#define SPI1_FIFO_SIZE 1024
#define SPI1_DMA_SIZE 1024
#define SPI1_CB_SIZE 1024

#define SPI2_FIFO_SIZE 1024
#define SPI2_DMA_SIZE 1024
#define SPI2_CB_SIZE 1024

// USART1
#define USART1_TX_SIZE 200
#define USART1_RX_SIZE 300

// CONSOLE
#define CONSOLE_MAX_INTERFACES 2
#define CONSOLE_CMD_SIZE 128
#define CONSOLE_PRINT_SIZE 256

// USB
#define USB_TX_SIZE 200
#define USB_RX_SIZE 300

/////////////////////////////////////////////////
// IRQ Levels
/////////////////////////////////////////////////

// DECT
#define IRQL_DECT_USART2 13
#define IRQL_DECT_DMA 14	// should be below USART2 IRQL

// SPI
#define IRQL_SPI1 14
#define IRQL_SPI2 14

// MOTOR
#define IRQL_MOTOR_HALL			3
#define IRQL_MOTOR_PWM_MOVEMENT	1
#define IRQL_MOTOR_PWM_DRIBBLER	2

// BUZZER
#define IRQL_BUZZER 15

// BUTTONS
#define IRQL_BUTTON1 15
#define IRQL_BUTTON2_AND_IR 13

// USB
#define IRQL_USB 15

// USART1
#define IRQL_USART1 14
#endif
