/*
 * ir.h
 *
 *  Created on: 04.07.2010
 *      Author: AndreR
 */

#ifndef __IR_H_
#define __IR_H_

#include "stm32f10x.h"

#include "util/atmega.h"
#include "atmega/ir_prog/ir_data.h"

#include "FreeRTOS.h"
#include "semphr.h"

#define IR_STATE_STANDBY 0
#define IR_STATE_ARMED 1

typedef struct _IR
{
	ATMega atmega;
	IRData data;

	volatile uint8_t state;
	volatile uint16_t fireDuration;
	volatile uint8_t level;
	volatile uint8_t device;

	xSemaphoreHandle hRun;

	uint8_t logEnabled;
} IRGlobal;

extern IRGlobal ir;

void IRInit();
void IRTask(void* params);
void IRArm(uint8_t device, uint16_t fireDuration, uint8_t level);
void IRDisarm();
void IRSetLog(uint8_t enable);

#endif /* IR_H_ */
