/*
 * power.h
 *
 *  Created on: 25.10.2010
 *      Author: AndreR
 */

#ifndef __POWER_H__
#define __POWER_H__

#include "stm32f10x.h"
#include "util/atmega.h"
#include "atmega/power_prog/power_data.h"

#define POWER_STATE_GOOD	0
#define POWER_STATE_LOW		1
#define POWER_STATE_OFF		2

typedef struct _PowerGlobal
{
	ATMega atmega;
	PowerData atData;

	uint8_t state;

	uint8_t blinkRed;
	uint8_t buzzerOn;
} PowerGlobal;

extern PowerGlobal power;

void PowerPreInit();
void PowerInit();
void PowerTask(void* params);
void PowerEnable5VSupply(uint8_t enable);
uint8_t PowerIs5VSupplyEnabled();

#endif
