/*
 * *********************************************************
 * Copyright (c) 2009 DHBW Mannheim - Tigers Mannheim
 * Project: tigers-robotControlUtility
 * Date: 19.11.2010
 * Authors: Clemens Teichmann <clteich@gmx.de>
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.robotcontrolutility.view;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;

import javax.swing.WindowConstants;

import org.apache.log4j.Logger;

import edu.dhbw.mannheim.tigers.robotcontrolutility.presenter.AControllerPresenter;
import edu.dhbw.mannheim.tigers.robotcontrolutility.presenter.RCUPresenter;
import edu.dhbw.mannheim.tigers.robotcontrolutility.view.actions.ExitAction;
import net.java.games.input.*;
import net.miginfocom.swing.MigLayout;


/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */

/**
 * @author Clemens
 * 
 */
public class MainFrame extends javax.swing.JFrame
{
	// --------------------------------------------------------------------------
	// --- class variables ------------------------------------------------------
	// --------------------------------------------------------------------------
	private static final long		serialVersionUID			= 6352025866749733669L;
	{
		// Set Look & Feel
		try
		{
			javax.swing.UIManager.setLookAndFeel(javax.swing.UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	
	// --- logger ---
	private Logger								log						= Logger.getLogger(RCUPresenter.class.getName());
	
	// --- MainFrame instance ---
	private static MainFrame		instance						= null;
	
	// --- GUI components ---
	private JMenuBar					mainMenuBar;
	private JMenu						configMenu;
	private JButton					startStopButton;
	private JButton					exitButton;
	private JButton					clearLoggingButton;
	private JTabbedPane				controllerTabbedPane;
	private JPanel						loggingPanel;
	private JPanel						programRunPanel;
	private JPanel						mainPanel;
	private JMenuItem					exitMenuItem;
	private JMenu						fileMenu;
	public JTextArea					loggingTextArea;
	private JScrollPane				loggingScrollPane;
	
	// --- list with all ControllerPanels
	private List<ControllerPanel>	controllerPanelS			= new ArrayList<ControllerPanel>();
	
	// --- status of startButton (start or stop pressed)
	private boolean					startButton					= true;
	
	// --- number of known controllers ---
	private static int				xboxControllerCount		= 0;
	private static int				logitechControllerCount	= 0;
	private static int				keyboardControllerCount = 0;
	
	
	/**
	 * Auto-generated main method to display this JFrame
	 */
	
	// -----------------------------------------------------------------
	// ----- Constructor -----------------------------------------------
	// -----------------------------------------------------------------
	private MainFrame()
	{
		super("Robot Control Utility");
		initGUI();
	}
	
	// -----------------------------------------------------------------
	// ----- Methods ---------------------------------------------------
	// -----------------------------------------------------------------	
	public static MainFrame getInstance()
	{
		if (instance == null)
			instance = new MainFrame();
		return instance;
	}
	
	// --- initiate MainFrame GUI ---
	private void initGUI()
	{
		try
		{
			// --- "disable" window close button ---
			this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
			// --- ExitAction added to window close button ---
			this.addWindowListener(new WindowAdapter()
			{
				public void windowClosing(WindowEvent event)
				{
					ExitAction.getInstance().actionPerformed(null);
				}
			});
			{
				// --- MainPanel with all Components --- 
				mainPanel = new JPanel();
				getContentPane().add(mainPanel, BorderLayout.CENTER);
				MigLayout mainPanelLayout = new MigLayout();
				mainPanelLayout.setColumnConstraints("[560.0]");
				mainPanelLayout.setRowConstraints("[86.0][242.0]2.0[210.0]");
				mainPanel.setLayout(mainPanelLayout);
				{
					// --- Panel with Programm Control Buttons ---
					programRunPanel = new JPanel();
					MigLayout programRunPanelLayout = new MigLayout();
					programRunPanelLayout.setRowConstraints("[45.0]");
					programRunPanelLayout.setColumnConstraints("[fill][][][]");
					programRunPanel.setLayout(programRunPanelLayout);
					mainPanel.add(programRunPanel, "cell 0 0");
					programRunPanel.setPreferredSize(new java.awt.Dimension(525, 64));
					{
						// --- Start-/StopButton ---
						startStopButton = new JButton();
						programRunPanel.add(startStopButton, "cell 0 0");
						startStopButton.setIcon(new ImageIcon(ClassLoader.getSystemResource("start.png")));
						startStopButton.addActionListener(new StartStopAction());
					}
					{
						// --- reset LoggingTextArea ---
						clearLoggingButton = new JButton();
						programRunPanel.add(clearLoggingButton, "cell 1 0");
						clearLoggingButton.setIcon(new ImageIcon(ClassLoader.getSystemResource("clean.png")));
						clearLoggingButton.addActionListener(new ClearLoggingAction());
					}
					{
						// --- close program ---
						exitButton = new JButton();
						programRunPanel.add(exitButton, "cell 2 0");
						exitButton.setIcon(new ImageIcon(ClassLoader.getSystemResource("exit.gif")));
						exitButton.addActionListener(ExitAction.getInstance());
					}
				}
				{
					// --- Panel with LoggingTextArea ---
					loggingPanel = new JPanel();
					MigLayout loggingPanelLayout = new MigLayout();
					loggingPanelLayout.setColumnConstraints("[531.0]");
					loggingPanelLayout.setRowConstraints("[145.0]");
					loggingPanel.setLayout(loggingPanelLayout);
					mainPanel.add(loggingPanel, "cell 0 2");
					loggingPanel.setPreferredSize(new java.awt.Dimension(560, 185));
					loggingPanel.setBorder(BorderFactory.createTitledBorder("Log"));
					{
						// --- Scrollpane to scroll on LoggingTextArea ---
						loggingScrollPane = new JScrollPane();
						loggingPanel.add(loggingScrollPane, "cell 0 0");
						loggingScrollPane.setPreferredSize(new java.awt.Dimension(531, 137));
						{
							// --- Log ---
							loggingTextArea = new JTextArea();
							loggingScrollPane.setViewportView(loggingTextArea);
							loggingTextArea.setEditable(false);
						}
					}
				}
				{
					// --- one Tab for each Controller - set below ---
					controllerTabbedPane = new JTabbedPane();
					mainPanel.add(controllerTabbedPane, "cell 0 1");
					controllerTabbedPane.setPreferredSize(new java.awt.Dimension(524, 61));
				}
			}
			{
				// --- MenuBar with additional features ---
				mainMenuBar = new JMenuBar();
				setJMenuBar(mainMenuBar);
				{
					// --- FileMenu ---
					fileMenu = new JMenu();
					mainMenuBar.add(fileMenu);
					fileMenu.setText("File");
					{
						exitMenuItem = new JMenuItem();
						fileMenu.add(exitMenuItem);
						exitMenuItem.setText("Exit");
						exitMenuItem.addActionListener(ExitAction.getInstance());
					}
				}
				{
					// --- ConfigMenu ---
					// TODO: implement SkillView
					configMenu = new JMenu();
					mainMenuBar.add(configMenu);
					configMenu.setText("Config");
				}
			}
			pack();
			this.setSize(600, 618);
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	
	
	/**
	 * Add new ControllerPanel and Tab for each Controller. Save this new ControllerPanel to controllerPanelS-List.
	 * @param newController
	 * @param controllerPresenter
	 * @return newControllerPanel
	 */
	public ControllerPanel addControllerPanel(Controller newController, AControllerPresenter controllerPresenter)
	{
		ControllerPanel newControllerPanel = new ControllerPanel(newController, controllerPresenter);
		controllerPanelS.add(newControllerPanel);
		controllerTabbedPane.addTab(this.checkControllerName(newController), null, newControllerPanel, null);
		return newControllerPanel;
	}
	

	/**
	 * Returns Name for Tabs. If Controller is known, set specified name and count amount of known controllers.
	 * @param knownController
	 * @return ControllerName
	 */
	private String checkControllerName(Controller knownController)
	{
		if (knownController.getName().equals("Controller (Xbox 360 Wireless Receiver for Windows)"))
		{
			xboxControllerCount++;
			return "XBox 360 Controller #" + xboxControllerCount;
		}
		if (knownController.getName().equals("Logitech Dual Action"))
		{
			logitechControllerCount++;
			return knownController.getName() + " #" + logitechControllerCount;
		} 
		if (knownController.getName().equals("Standardtastatur (PS/2)"))
		{
			keyboardControllerCount++;
			return knownController.getType() + " #" + keyboardControllerCount;
		} 
		else
			return knownController.getType().toString();
	}
	

	/**
	 * Sets MainFrame Title.
	 * @param newTitle
	 */
	public void setMainFrameTitle(String newTitle)
	{
		this.setTitle("Robot Control Utility " + newTitle);
	}
	
	// --------------------------------------------------------------------------
	// --- inner classes --------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * Action to clear LoggingTextArea
	 * @author Clemens
	 *
	 */
	private class ClearLoggingAction implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			loggingTextArea.setText("");
		}
	}
	
	/**
	 * Action to set Start/Stop Button, run application and disable ControllerPanels
	 * @author Clemens
	 *
	 */
	private class StartStopAction implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			// --- start button shown ---
			if (startButton)
			{
				int i=1;
				boolean atLeastOneControllerIsConnected = false;
				// --- initialize connections and check if they're successfully set up. ---
				for(boolean isConnected : RCUPresenter.getInstance().onStartStopButtonPressed(startButton))
				{
					if(!isConnected)
					{
						log.warn("Controller of the Tab #"+i+" couldn't connect to Server. Maybe wrong IP!?");
					}
					// --- there should be at least one successfully established connection for polling and sending ---
					else
					{
						atLeastOneControllerIsConnected = true;
					}
					i++;
				}
				// --- start polling - if successfully started, change GUI ---
				if (atLeastOneControllerIsConnected)
				{
					// --- Start to Stop Button ---
					startStopButton.setIcon(new ImageIcon(ClassLoader.getSystemResource("stop.png")));
					startButton = false;
					
					// --- disable all Panels with their components
					for (ControllerPanel cP : controllerPanelS)
					{
						for (java.awt.Component childComponent : cP.getComponents())
						{
							if (childComponent instanceof Container)
							{
								Container childContainer = (Container) childComponent;
								for (java.awt.Component childChildComponent : childContainer.getComponents())
								{
									childChildComponent.setEnabled(false);
								}
							}
						}
					}
				}
			} 
			// --- stop button shown ----
			else
			{
				// --- Stop to Start Button ---
				RCUPresenter.getInstance().onStartStopButtonPressed(startButton);
				startStopButton.setIcon(new ImageIcon(ClassLoader.getSystemResource("start.png")));
				startButton = true;
				
				// --- enable all Panels with their components
				for (ControllerPanel cP : controllerPanelS)
				{
					for (java.awt.Component childComponent : cP.getComponents())
					{
						if (childComponent instanceof Container)
						{
							Container childContainer = (Container) childComponent;
							for (java.awt.Component childChildComponent : childContainer.getComponents())
							{
								childChildComponent.setEnabled(true);
							}
						}
					}
				}
			}
		}
	}
}
