/*
 * *********************************************************
 * Copyright (c) 2009 DHBW Mannheim - Tigers Mannheim
 * Project: tigers-centralSoftware
 * Date: 02.09.2009
 * Authors: Bernhard Perun <bernhard.perun@googlemail.com>
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.robotcontrolutility.view.utils;


import javax.swing.JTextArea;
import org.apache.log4j.*;
import org.apache.log4j.spi.LoggingEvent;


/**
 * Simple Log4j appender which is able to write log4j-messages to a JTextArea.
 */
public class TextAreaAppender extends WriterAppender
{
	// --------------------------------------------------------------------------
	// --- instance-variables ---------------------------------------------------
	// --------------------------------------------------------------------------
	private JTextArea	jTextArea	= null;
	private Layout		layout		= null;
	
	
	// --------------------------------------------------------------------------
	// --- constructor(s) -------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * Specify textArea and layout for logging.
	 * @param jTextArea swing-jTextArea
	 * @param layout log4j-layout
	 */
	public TextAreaAppender(JTextArea jTextArea, Layout layout)
	{
		this.jTextArea = jTextArea;
		this.layout = layout;
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * Format and append loggingEvent to textArea.
	 */
	public void append(LoggingEvent loggingEvent)
	{
		final String message = this.layout.format(loggingEvent);
		
		// --- append message ---
		jTextArea.append(message);
		
		// --- scroll jTextArea to the end ---
		jTextArea.setCaretPosition(jTextArea.getDocument().getLength());
	}
	
}
