/*
 * *********************************************************
 * Copyright (c) 2009 - 2010, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - RCU
 * Date: 20.10.2010
 * Author(s): Lukas
 * 
 * *********************************************************
 */

package testServer;

import java.util.HashMap;
import java.util.Map;

/**
 * This class opens a Receiver for a Bot. (just Test)
 * 
 * @author Lukas
 * 
 */
public class Server
{
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	
	private final Map<Integer, RCReceiver>	receivers	= new HashMap<Integer, RCReceiver>();
	private final int								startPort;
	private int										count			= 0;
	private SetUpServerFrame					frame			= null;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	public Server(int startPort)
	{
		frame = SetUpServerFrame.getInstance();
		this.startPort = startPort;
		startModule();
	}
	

	// --------------------------------------------------------------------------
	// --- lifecycle ------------------------------------------------------------
	// --------------------------------------------------------------------------
	
	public void startModule()
	{
		addBotReceiver();
	}

	public void stopModule()
	{
		count = 0;
		// --- close threads ---
		for (RCReceiver rec : receivers.values())
		{
			rec.close();
		}
		receivers.clear();
	}
	

	public void addBotReceiver()
	{
		Bot bot = new Bot(-1,"This Bot shouldn't exist!");
		switch(count)
		{
			case 0:
				bot = new Bot(0,"Sonny");
				break;
			case 1:
				bot = new Bot(1,"Nummer 5");
				break;
			case 2:
				bot = new Bot(2,"Aibo");
				break;
			case 3:
				bot = new Bot(3,"R2D2");
				break;
			default :
				frame.setOutput("The Maximum (4 Bots) is reached!");
				return;
		}
		RCReceiver receiver = new RCReceiver(startPort + count, bot);
		receiver.startReceiver();
		receivers.put(bot.getBotId(), receiver);
		if(frame==null)
			System.out.println("hi");
		frame.setOutput("Bot "+bot.getBotName()+" added");
		count++;
	}
}
