/*
 * *********************************************************
 * Copyright (c) 2009 - 2010, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - RCU
 * Date: 20.10.2010
 * Author(s): Lukas
 * 
 * *********************************************************
 */

package testServer;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
//import java.io.IOException;

import javax.swing.*;

/**
 * This class builds the GUI for the TestServer. (just Test)
 * 
 * @author Lukas
 * 
 */

public class SetUpServerFrame extends JFrame implements ActionListener
{

	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	
	private static final long serialVersionUID = 1L;
	private JPanel buttonPanel						= new JPanel(new BorderLayout());
	private JPanel portPanel						= new JPanel(new BorderLayout());
	private JLabel portLabel						= new JLabel("StartPortnr.:");
	private JTextField portField					= new JTextField("40000");
	private JTextArea output						= new JTextArea();
	private JButton setUpButton					= new JButton("Set up");
	private JButton closeButton					= new JButton("Close");
	private JButton addBotButton					= new JButton("Add Bot");
	private JScrollPane scrollPane				= new JScrollPane(output);
	public static SetUpServerFrame instance	= null;
	public Server myServer							= null;
	public boolean isSetUp							= false;
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	
	private SetUpServerFrame()
	{
		super("Set up Server");
		initGUI();
		initActions();
	}

	// --------------------------------------------------------------------------
	// --- method(s) ------------------------------------------------------------
	// --------------------------------------------------------------------------
	
	public static SetUpServerFrame getInstance()
	{
		if(instance == null)
		{
			instance = new SetUpServerFrame();
		}
		return instance;
	}
	
	private void initGUI()
	{
		this.setSize(210, 100);
		this.setLocation(400,200);
		this.setMinimumSize(new Dimension(300,300));
		this.setLayout(new BorderLayout());
		this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(new WindowListener()
		{
			public void windowActivated(WindowEvent arg0){}
			public void windowClosed(WindowEvent arg0){}
			public void windowClosing(WindowEvent arg0)
			{
				new AbortAction().actionPerformed(null);
			}
			public void windowDeactivated(WindowEvent arg0){}
			public void windowDeiconified(WindowEvent arg0){}
			public void windowIconified(WindowEvent arg0){}
			public void windowOpened(WindowEvent arg0){}
		});
		portPanel.add(portLabel,BorderLayout.WEST);
		portPanel.add(portField);
		addBotButton.setEnabled(false);
		buttonPanel.add(setUpButton,BorderLayout.WEST);
		buttonPanel.add(addBotButton,BorderLayout.CENTER);
		buttonPanel.add(closeButton,BorderLayout.EAST);
		output.setEnabled(false);
		output.setDisabledTextColor(Color.black);
		this.add(portPanel,BorderLayout.NORTH);
		this.add(scrollPane);
		this.add(buttonPanel,BorderLayout.SOUTH);
		this.setVisible(true);
	}
	
	private void initActions()
	{
		setUpButton.addActionListener(this);
		addBotButton.addActionListener(this);
		closeButton.addActionListener(new AbortAction());
	}

	public void close()
	{
		this.setVisible(false);
		if(myServer!=null)
		{
			System.out.println("Shut Server down");
			myServer.stopModule();
		}
	}
	
		public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals("Set up"))
		{
			if(myServer == null)
			{
				int portNumber 	= getPort();
				myServer = new Server(portNumber);
				isSetUp=true;
				setUpButton.setEnabled(false);
				portField.setEnabled(false);
				addBotButton.setEnabled(true);
			}
		}
		if(arg0.getActionCommand().equals("Add Bot"))
		{
			myServer.addBotReceiver();
		}
	}
	
public void setOutput(String msg)
	{
		output.append(msg+"\n");
	}
	
	public int getPort()
	{
		return Integer.parseInt(portField.getText());
	}
}
