package edu.dhbw.mannheim.tigers.sim.engine;

import com.jme.system.PropertiesGameSettings;


/**
 * Data-holder for basic engine settings.
 * 
 * @author Gero
 */
public class SimEngineSettings extends PropertiesGameSettings {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	public static final String			ENGINE_SETTINGS_PATH	= "properties/simengine.cfg";
	
	public static final Boolean		DEFAULT_FULLSCREEN	= Boolean.FALSE;
	public static final int				DEFAULT_DEPTH			= 24;
	public static final int				DEFAULT_FREQUENZY		= -1;
	public static final int				DEFAULT_WIDTH			= 800;
	public static final int				DEFAULT_HEIGHT			= 600;
	public static final int				DEFAULT_SAMPLES		= 0;									// 6;
	public static final String			DEFAULT_RENDERER		= "LWJGL";
	
	/**
	 * Populates the GameSettings from the (session-specific) .properties
	 * file.
	 */
	private static SimEngineSettings	instance					= null;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	public static SimEngineSettings getInstance() {
		if (instance == null) {
			instance = new SimEngineSettings();
		}
		return instance;
	}
	

	/**
	 * @see SimEngineSettings
	 */
	private SimEngineSettings() {
		super(ENGINE_SETTINGS_PATH);
		this.setDefaults();
		load();
	}
	

	public void setDefaults() {
		this.setIsNew(false);
		this.setFullscreen(DEFAULT_FULLSCREEN);
		this.setDepth(DEFAULT_DEPTH);
		this.setFrequency(DEFAULT_FREQUENZY);
		this.setWidth(DEFAULT_WIDTH);
		this.setHeight(DEFAULT_HEIGHT);
		this.setSamples(DEFAULT_SAMPLES);
		this.setRenderer(DEFAULT_RENDERER);
	}
}
