package edu.dhbw.mannheim.tigers.sim.engine.com;

import java.util.List;

import edu.dhbw.mannheim.tigers.sim.engine.model.ball.IBallModelControl;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.BotID;
import edu.dhbw.mannheim.tigers.sim.engine.model.data.field.IRoboCupFieldData;



/**
 * This interface grants comprehensive access to the control-objects of all instances during a robocup-match
 * 
 * @author Gero
 */
public interface IRoboCupControlProvider extends IRoboCupMatchControlProvider {
	
	
	/**
	 * @return The {@link IBallModelControl} of the ball currently in the game
	 */
	public IBallModelControl getBall();
	
	
	/**
	 * @return A list of {@link BotID} identifying all bots in the game
	 */
	public List<BotID> getBots();
	
	
	
	/**
	 * @return The {@link IRoboCupFieldData} the RoboCup field in this match is build with.
	 */
	public IRoboCupFieldData getFieldData();
}
