package edu.dhbw.mannheim.tigers.sim.engine.com;

import java.util.List;

import edu.dhbw.mannheim.tigers.sim.engine.model.IBasicModelControl;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.BotID;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.IBasicBotModelControl;


/**
 * This interface grants basic access to the control-objects of all instances during a robocup-match
 * 
 * @author Gero
 */
public interface IRoboCupMatchControlProvider {
	
	/**
	 * @param team
	 * @return All {@link BotID}s of the robots in the {@link ERoboCupTeam}
	 */
	public List<BotID> getTeamIDs(ERoboCupTeam team);
	

	/**
	 * @param id
	 * @return The {@link IBasicBotModelControl} of the robot identified by the {@link BotID}
	 */
	public IBasicBotModelControl getBot(BotID id);
	

	/**
	 * @param id
	 * @return The {@link ERoboCupTeam} the given {@link BotID} is in (or <code>null</code> if the id could not be
	 *         found!)
	 */
	public ERoboCupTeam getTeam(BotID id);
	

	/**
	 * @return The {@link IBasicModelControl}
	 */
	public IBasicModelControl getBall();
}
