package edu.dhbw.mannheim.tigers.sim.engine.com.bot;


/**
 * Helps encapsulating the {@link ABotController} from the parts that receives the message (
 * {@link ABotCommandReceiver})
 * 
 * @author Gero
 * 
 * @param <C> Command base-type
 */
public interface IBotCommandInterpreter<C> {
	
	/**
	 * @param blocked Whether the input should be blocked or not
	 */
	public abstract void setBlocked(boolean blocked);
	

	/**
	 * @return blocked Whether the input s blocked or not
	 */
	public abstract boolean isBlocked();
	

	/**
	 * Interprets the given command
	 * 
	 * @param cmd
	 */
	public abstract void processNewCommand(C cmd);
}