package edu.dhbw.mannheim.tigers.sim.engine.com.bot;


/**
 * Interface that encapsulates/bunches methods provided by the {@link ABotController} to the
 * botcom-trio ({@link ABotCommunicator}, {@link ABotCommandReceiver}, {@link ABotStatusTransmitter}
 * )
 * 
 * @author Gero
 * 
 * @param <C> The command base-type
 */
public interface IBotController<C> extends IBotCommandInterpreter<C>, IBotStatusProvider<C> {
	
	/**
	 * Called whenever the {@link ABotCommunicator} is disconnected
	 */
	public void onDisconnect();

	/**
	 * Called whenever the {@link ABotCommunicator} is connected
	 */
	public void onConnect();
}
