package edu.dhbw.mannheim.tigers.sim.engine.com.bot;

import java.util.List;

import edu.dhbw.mannheim.tigers.sim.engine.model.bot.BotID;


/**
 * Interfaces that encapsulates the {@link ABotController} from the unit that sends the any kind of
 * bot status message
 * 
 * @author Gero
 * 
 * @param <S>	Type of bot status message
 */
public interface IBotStatusProvider<S> {
	
	/**
	 * @param store The list that the status-messages are attached to
	 * @return Reference to store for easy chaining
	 */
	public List<S> getBotStatus(List<S> store);
   
	
   /**
    * @return The {@link BotID} of the corresponding bot
    */
   public BotID getID();
}
