package edu.dhbw.mannheim.tigers.sim.engine.delegates;


import com.jme.scene.Node;

import edu.dhbw.mannheim.tigers.sim.engine.ICore;
import edu.dhbw.mannheim.tigers.sim.engine.model.SimPhysicsPicker;
import edu.dhbw.mannheim.tigers.sim.engine.model.UserData;
import edu.dhbw.mannheim.tigers.sim.engine.model.UserData.Value;


/**
 * Provides the user a way to "pick" certain objects with the mouse. These objects are detected by a
 * {@link SimPhysicsPicker}, which checks the nodes that are targeted by calling {@link Node#getUserData(String)}. If
 * this returns {@link Value#TRUE} on {@link UserData#PICKABLE}, it is picked!
 * 
 * @author Gero
 */
public class MousePickingDelegate extends ASimDelegate {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	private SimPhysicsPicker	picker	= null;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @see MousePickingDelegate
	 * @param core
	 */
	public MousePickingDelegate(ICore core) {
		super(core);
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	public void initSystem() {
		
		picker = new SimPhysicsPicker(core.getInputHandler(), core.getDynamics(), core.getPhysicsSpace(), false);
		picker.setPickModeVisual(true);
	}
	

	@Override
	public void cleanup() {
		picker.delete();
	}
}
