package edu.dhbw.mannheim.tigers.sim.engine.model.ball;

import java.util.List;

import edu.dhbw.mannheim.tigers.sim.engine.model.data.ball.IBallModelData;


/**
 * Provides access to ball data
 * 
 * @author Gero
 */
public interface IBallModelDataProvider {
	
	/**
	 * @param type
	 * @return The {@link IBallModelData} of for the given type. If <code>type == null</code> or there is no data
	 *         associated with it, default data is returned.
	 */
	public IBallModelData getRoboCupBallData(String type);
	

	/**
	 * @return A list of the available ball-types
	 */
	public abstract List<String> getAvailableBallTypes();
}
