package edu.dhbw.mannheim.tigers.sim.engine.model.bot.tiger;


import edu.dhbw.mannheim.tigers.sim.engine.com.bot.tiger.TigerBotController;


/**
 * Contains everything the {@link TigerBotController} needs from the {@link TigerBotModel} to create
 * a satisfying status message which can be sent to the CS
 * 
 * @author Gero
 */
public class TigerBotStatus {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	public final TigerMove	move;
	
	/** [V] */
	public final int			currentCharge;
	

	/** Whether the capacitor is loading */
	public final boolean		isCapLoading;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * Constructor
	 * 
	 * @param {@link #move}
	 * @param currentCharge
	 * @param isCapLoading
	 */
	public TigerBotStatus(TigerMove move, int currentCharge, boolean isCapLoading) {
		super();
		
		this.move = move;
		
		this.currentCharge = currentCharge;
		this.isCapLoading = isCapLoading;
	}
	

	@Override
	public String toString() {
		return "[TigerBotStatus | vx=" + move.vx + "; vy=" + move.vy + "; vw=" + move.vw + " / charge=" + currentCharge
				+ "; isLoading=" + isCapLoading + " ]";
	}
}
