package edu.dhbw.mannheim.tigers.sim.engine.model.field;


import java.util.List;

import edu.dhbw.mannheim.tigers.sim.engine.model.data.field.IRoboCupFieldData;
import edu.dhbw.mannheim.tigers.sim.exceptions.SimModelException;


/**
 * Typical data-provider. Gives a list of possible field-types and retrieves the data for a special one
 * 
 * @author Gero
 */
public interface IRoboCupFieldDataProvider {
	
	/**
	 * @param type
	 * @return The {@link IRoboCupFieldData} associated with the given type. If <code>type == null</code> or there is no
	 *         associated data, default data is returned.
	 * @throws SimModelException
	 */
	public abstract IRoboCupFieldData getFieldData(String type);
	

	/**
	 * @return A list of availabe field-types
	 */
	public abstract List<String> getAvailableFieldTypes();
}