package edu.dhbw.mannheim.tigers.sim.engine.modes;

import java.util.HashMap;


/**
 * The differen simulation-modes
 * 
 * @author Gero
 */
public enum ESimEngineMode {
	
	/** For testing/development purposes */
	TEST,
	
	/** Simulates a RoboCup-match */
	MATCH,
	
	/** Simulates nothing, simply displays data provided by the AI via the "viszualization"-module */
	DISPLAY;
	
	// SHOOTER;
	

	private static ESimEngineMode							defaultLiteral;
	private static HashMap<String, ESimEngineMode>	enums;
	
	
	/**
	 * @see ESimEngineMode
	 */
	private ESimEngineMode() {
		register(this);
	}
	

	private static void register(ESimEngineMode newMode) {
		
		if (enums == null) {
			enums = new HashMap<String, ESimEngineMode>();
		}
		
		enums.put(newMode.toString(), newMode);
		
		if (defaultLiteral == null) {
			defaultLiteral = newMode;
		}
	}
	

	/**
	 * Null-safe.
	 * 
	 * @param literal
	 * @return {@link #defaultLiteral}, if there is no literal represented by the given string.
	 */
	public static ESimEngineMode getEnumOf(String literal) {
		
		ESimEngineMode result = enums.get(literal);
		
		if (result == null) {
			result = defaultLiteral;
		}
		
		return result;
	}
}
