package edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization;

import com.jme.scene.Node;
import com.jme.system.DisplaySystem;

import edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization.SimVisMessages.SimVisData;
import edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization.SimVisMessages.SimVisData.Poi;


/**
 * Implementation of {@link APOIDrawer} that draws the ball.
 * 
 * @author Gero
 */
public class DefaultBallDrawer extends APOIDrawer {
   
   /**
     * @see DefaultBallDrawer
     * @param root
     * @param renderQueueMode
     * @param display
     */
   public DefaultBallDrawer(Node root, int renderQueueMode, DisplaySystem display) {
      super(root, renderQueueMode, display);
   }
   
   
   @Override
   public void displayInfo(SimVisData data) {
   	doDisplayInfo(data.getBallsList());
   }
   
   
   @Override
   protected AVisualObject createSinglePoi(Poi poi) {
      return new PredictedBall(poi, localRoot, display);
   }
   
}
