package edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization;

import com.jme.scene.Node;
import com.jme.system.DisplaySystem;

import edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization.SimVisMessages.SimVisData;
import edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization.SimVisMessages.SimVisData.Poi;

/**
 * This first implementations is meant to visualize debug-points
 * 
 * @author Gero
 */
public class DefaultSituationsDrawer extends APOIDrawer {
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	  * @see DefaultSituationsDrawer
	  * @param root
	  * @param renderQueueMode
	  * @param display
	  */
	public DefaultSituationsDrawer(Node root, int renderQueueMode, DisplaySystem display) {
		super(root, renderQueueMode, display);
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	public void displayInfo(SimVisData data) {
		undisplayInfo();
		doDisplayInfo(data.getSituationsList());
	}
	

	@Override
	protected AVisualObject createSinglePoi(Poi poi) {
		return new DebugPoint(poi, localRoot, display);
	}
}
