package edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization;


import java.util.Map;

import edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization.SimVisMessages.SimVisData;



/**
 * This interface encapsulates the ability to display {@link SimVisData} (or parts of it)
 * 
 * @author Gero
 */
public interface IDrawer {
	
	/**
	 * Lets subclasses decide which part of 'data' should be displayed by {@link #doDisplayInfo(Map)}
	 * 
	 * @param data
	 */
	public abstract void displayInfo(SimVisData data);
	

	/**
	 * Removes every displayed bot-info which is still present
	 */
	public abstract void undisplayInfo();
}