package edu.dhbw.mannheim.tigers.sim.engine.resources;

import java.awt.Image;

import com.jme.image.Texture;

import edu.dhbw.mannheim.tigers.sim.engine.resources.TextureProvider.ETexIndex;
import edu.dhbw.mannheim.tigers.sim.exceptions.SimResourceException;
import edu.dhbw.mannheim.tigers.sim.resources.IResourceProvider;


/**
 * A singleton provider that holds {@link Texture}s loaded on application startup.
 * 
 * @author Gero
 * 
 */
public interface ITextureProvider extends IResourceProvider {
	
	public static final ITextureProvider	INSTANCE	= TextureProvider.getInstance();
	
	
	/**
	 * Gives the user access to the stored {@link Image}s.
	 * 
	 * @param key
	 * @return
	 * @throws SimResourceException
	 */
	public abstract Image getImage(ETexIndex key) throws SimResourceException;
	

	/**
	 * Gives the user access to the stored {@link Image}s.
	 * 
	 * @param key
	 * @return
	 * @throws SimResourceException
	 */
	public abstract Texture getTexture(ETexIndex key) throws SimResourceException;
}