package edu.dhbw.mannheim.tigers.sim.gui.swing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;

import edu.dhbw.mannheim.tigers.sim.engine.modes.ESimEngineMode;
import edu.dhbw.mannheim.tigers.sim.settings.ISettingsProvider;
import edu.dhbw.mannheim.tigers.sim.settings.data.ISimProperties;



/**
 * This switch lets the user decide which mode he want run
 * 
 * @author Gero
 */
public class EngineModeSwitch extends JComboBox {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	private static final long	serialVersionUID	= -7288826545749144140L;
	
	
	/**
	  * @see EngineModeSwitch
	  */
	public EngineModeSwitch() {
		super(ESimEngineMode.values());
		
		final ISimProperties properties = ISettingsProvider.INSTANCE.getSimProperties();
		
		// SelectionListener
		this.addActionListener (new ActionListener () {
		    public void actionPerformed(ActionEvent e) {
		        properties.setDefaultSimEngineMode(((JComboBox)e.getSource()).getSelectedItem().toString());
		    }
		});
		
		// Get default value
		String defaultMode = properties.getDefaultSimEngineMode();
		
		ESimEngineMode mode = ESimEngineMode.getEnumOf(defaultMode);
		
		this.setSelectedItem(mode);
	}
}
