package edu.dhbw.mannheim.tigers.sim.gui.swing;

import javax.swing.JTextArea;

import org.apache.log4j.AppenderSkeleton;
import org.apache.log4j.spi.LoggingEvent;


/**
 * Appends log-infos to the info-area of the {@link SimMainWindow}
 * 
 * @author Gero
 * 
 */
public class LogAppender extends AppenderSkeleton {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	private JTextArea		loggingArea			= null;
	private final Object	loggingAreaSync	= new Object();
	
	private String			message				= "";
	private boolean		blocked				= false;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @see LogAppender
	 * @param loggingArea
	 */
	public LogAppender(JTextArea loggingArea) {
		this.loggingArea = loggingArea;
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	protected void append(LoggingEvent loggingEvent) {
		
		synchronized (loggingAreaSync) {
			if (blocked) {
				return;
			}
			
			message = this.layout.format(loggingEvent);
			
			try {
				loggingArea.append(message);
			} catch (java.lang.Error e) { /* TODO Determine the cause for this error... */
			}
		}
	}
	

	@Override
	public void close() {
		blocked = true;
	}
	

	@Override
	public boolean requiresLayout() {
		return false;
	}
}
