package edu.dhbw.mannheim.tigers.sim.gui.swing.settings;


/**
 * Interface for all Settingspanel, such as EngineSettings, SimSettings, ModelSettings.
 * 
 * @author Gero, Malte
 *
 */
public interface ISettingsPanel {
	
	/**
	 * This method must be called manually!!!
	 */
	public void initialize();
	
	/**
	 * @return Whether the input from this panel is correct!
	 */
	public boolean checkInput();
	
	/**
	 * Writes the input from the Gui to the actual settings-object
	 */
	public void apply();
	
	/**
	 * Resets the Guis values to the ones from the settings-object
	 */
	public void revert();
	
	/**
	 * Creates a default instances of the settings-object and writes them to the gui
	 */
	public void defaults();
	
	
	/**
	 * @return The panels title
	 */
	public String getTitle();
}
