package edu.dhbw.mannheim.tigers.sim.settings;

import edu.dhbw.mannheim.tigers.sim.exceptions.SimSettingsException;
import edu.dhbw.mannheim.tigers.sim.resources.IResourceProvider;
import edu.dhbw.mannheim.tigers.sim.settings.data.ISimProperties;


/**
 * The interface that provides access to the current {@link ISimProperties} instance
 * 
 * @author Gero
 */
public interface ISettingsProvider extends IResourceProvider {
	
	ISettingsProvider INSTANCE = SettingsProvider.getInstance();
	
	/**
	 * @return Current {@link ISimProperties} instance
	 * @throws SimSettingsException
	 */
	public ISimProperties getSimProperties() throws SimSettingsException;
	
	
	/**
	 * Actually saves the current settings to file
	 */
	public void persist();
}
